// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from uvms_msgs:msg/ControlTargetPrediction.idl
// generated code does not contain a copyright notice
#include "uvms_msgs/msg/detail/control_target_prediction__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `target`
// Member `target_forward`
#include "hippo_control_msgs/msg/detail/control_target__functions.h"

bool
uvms_msgs__msg__ControlTargetPrediction__init(uvms_msgs__msg__ControlTargetPrediction * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    uvms_msgs__msg__ControlTargetPrediction__fini(msg);
    return false;
  }
  // target
  if (!hippo_control_msgs__msg__ControlTarget__init(&msg->target)) {
    uvms_msgs__msg__ControlTargetPrediction__fini(msg);
    return false;
  }
  // target_forward
  if (!hippo_control_msgs__msg__ControlTarget__init(&msg->target_forward)) {
    uvms_msgs__msg__ControlTargetPrediction__fini(msg);
    return false;
  }
  // dt
  return true;
}

void
uvms_msgs__msg__ControlTargetPrediction__fini(uvms_msgs__msg__ControlTargetPrediction * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // target
  hippo_control_msgs__msg__ControlTarget__fini(&msg->target);
  // target_forward
  hippo_control_msgs__msg__ControlTarget__fini(&msg->target_forward);
  // dt
}

bool
uvms_msgs__msg__ControlTargetPrediction__are_equal(const uvms_msgs__msg__ControlTargetPrediction * lhs, const uvms_msgs__msg__ControlTargetPrediction * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // target
  if (!hippo_control_msgs__msg__ControlTarget__are_equal(
      &(lhs->target), &(rhs->target)))
  {
    return false;
  }
  // target_forward
  if (!hippo_control_msgs__msg__ControlTarget__are_equal(
      &(lhs->target_forward), &(rhs->target_forward)))
  {
    return false;
  }
  // dt
  if (lhs->dt != rhs->dt) {
    return false;
  }
  return true;
}

bool
uvms_msgs__msg__ControlTargetPrediction__copy(
  const uvms_msgs__msg__ControlTargetPrediction * input,
  uvms_msgs__msg__ControlTargetPrediction * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // target
  if (!hippo_control_msgs__msg__ControlTarget__copy(
      &(input->target), &(output->target)))
  {
    return false;
  }
  // target_forward
  if (!hippo_control_msgs__msg__ControlTarget__copy(
      &(input->target_forward), &(output->target_forward)))
  {
    return false;
  }
  // dt
  output->dt = input->dt;
  return true;
}

uvms_msgs__msg__ControlTargetPrediction *
uvms_msgs__msg__ControlTargetPrediction__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  uvms_msgs__msg__ControlTargetPrediction * msg = (uvms_msgs__msg__ControlTargetPrediction *)allocator.allocate(sizeof(uvms_msgs__msg__ControlTargetPrediction), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(uvms_msgs__msg__ControlTargetPrediction));
  bool success = uvms_msgs__msg__ControlTargetPrediction__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
uvms_msgs__msg__ControlTargetPrediction__destroy(uvms_msgs__msg__ControlTargetPrediction * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    uvms_msgs__msg__ControlTargetPrediction__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
uvms_msgs__msg__ControlTargetPrediction__Sequence__init(uvms_msgs__msg__ControlTargetPrediction__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  uvms_msgs__msg__ControlTargetPrediction * data = NULL;

  if (size) {
    data = (uvms_msgs__msg__ControlTargetPrediction *)allocator.zero_allocate(size, sizeof(uvms_msgs__msg__ControlTargetPrediction), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = uvms_msgs__msg__ControlTargetPrediction__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        uvms_msgs__msg__ControlTargetPrediction__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
uvms_msgs__msg__ControlTargetPrediction__Sequence__fini(uvms_msgs__msg__ControlTargetPrediction__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      uvms_msgs__msg__ControlTargetPrediction__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

uvms_msgs__msg__ControlTargetPrediction__Sequence *
uvms_msgs__msg__ControlTargetPrediction__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  uvms_msgs__msg__ControlTargetPrediction__Sequence * array = (uvms_msgs__msg__ControlTargetPrediction__Sequence *)allocator.allocate(sizeof(uvms_msgs__msg__ControlTargetPrediction__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = uvms_msgs__msg__ControlTargetPrediction__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
uvms_msgs__msg__ControlTargetPrediction__Sequence__destroy(uvms_msgs__msg__ControlTargetPrediction__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    uvms_msgs__msg__ControlTargetPrediction__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
uvms_msgs__msg__ControlTargetPrediction__Sequence__are_equal(const uvms_msgs__msg__ControlTargetPrediction__Sequence * lhs, const uvms_msgs__msg__ControlTargetPrediction__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!uvms_msgs__msg__ControlTargetPrediction__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
uvms_msgs__msg__ControlTargetPrediction__Sequence__copy(
  const uvms_msgs__msg__ControlTargetPrediction__Sequence * input,
  uvms_msgs__msg__ControlTargetPrediction__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(uvms_msgs__msg__ControlTargetPrediction);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    uvms_msgs__msg__ControlTargetPrediction * data =
      (uvms_msgs__msg__ControlTargetPrediction *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!uvms_msgs__msg__ControlTargetPrediction__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          uvms_msgs__msg__ControlTargetPrediction__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!uvms_msgs__msg__ControlTargetPrediction__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
