// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from uvms_msgs:msg/TaskPriorityDebug.idl
// generated code does not contain a copyright notice
#include "uvms_msgs/msg/detail/task_priority_debug__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `activation_values`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
uvms_msgs__msg__TaskPriorityDebug__init(uvms_msgs__msg__TaskPriorityDebug * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    uvms_msgs__msg__TaskPriorityDebug__fini(msg);
    return false;
  }
  // desired_velocity
  // projected_velocity
  // active_tasks
  // activation_values
  if (!rosidl_runtime_c__double__Sequence__init(&msg->activation_values, 0)) {
    uvms_msgs__msg__TaskPriorityDebug__fini(msg);
    return false;
  }
  return true;
}

void
uvms_msgs__msg__TaskPriorityDebug__fini(uvms_msgs__msg__TaskPriorityDebug * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // desired_velocity
  // projected_velocity
  // active_tasks
  // activation_values
  rosidl_runtime_c__double__Sequence__fini(&msg->activation_values);
}

bool
uvms_msgs__msg__TaskPriorityDebug__are_equal(const uvms_msgs__msg__TaskPriorityDebug * lhs, const uvms_msgs__msg__TaskPriorityDebug * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // desired_velocity
  for (size_t i = 0; i < 10; ++i) {
    if (lhs->desired_velocity[i] != rhs->desired_velocity[i]) {
      return false;
    }
  }
  // projected_velocity
  for (size_t i = 0; i < 10; ++i) {
    if (lhs->projected_velocity[i] != rhs->projected_velocity[i]) {
      return false;
    }
  }
  // active_tasks
  if (lhs->active_tasks != rhs->active_tasks) {
    return false;
  }
  // activation_values
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->activation_values), &(rhs->activation_values)))
  {
    return false;
  }
  return true;
}

bool
uvms_msgs__msg__TaskPriorityDebug__copy(
  const uvms_msgs__msg__TaskPriorityDebug * input,
  uvms_msgs__msg__TaskPriorityDebug * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // desired_velocity
  for (size_t i = 0; i < 10; ++i) {
    output->desired_velocity[i] = input->desired_velocity[i];
  }
  // projected_velocity
  for (size_t i = 0; i < 10; ++i) {
    output->projected_velocity[i] = input->projected_velocity[i];
  }
  // active_tasks
  output->active_tasks = input->active_tasks;
  // activation_values
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->activation_values), &(output->activation_values)))
  {
    return false;
  }
  return true;
}

uvms_msgs__msg__TaskPriorityDebug *
uvms_msgs__msg__TaskPriorityDebug__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  uvms_msgs__msg__TaskPriorityDebug * msg = (uvms_msgs__msg__TaskPriorityDebug *)allocator.allocate(sizeof(uvms_msgs__msg__TaskPriorityDebug), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(uvms_msgs__msg__TaskPriorityDebug));
  bool success = uvms_msgs__msg__TaskPriorityDebug__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
uvms_msgs__msg__TaskPriorityDebug__destroy(uvms_msgs__msg__TaskPriorityDebug * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    uvms_msgs__msg__TaskPriorityDebug__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
uvms_msgs__msg__TaskPriorityDebug__Sequence__init(uvms_msgs__msg__TaskPriorityDebug__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  uvms_msgs__msg__TaskPriorityDebug * data = NULL;

  if (size) {
    data = (uvms_msgs__msg__TaskPriorityDebug *)allocator.zero_allocate(size, sizeof(uvms_msgs__msg__TaskPriorityDebug), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = uvms_msgs__msg__TaskPriorityDebug__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        uvms_msgs__msg__TaskPriorityDebug__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
uvms_msgs__msg__TaskPriorityDebug__Sequence__fini(uvms_msgs__msg__TaskPriorityDebug__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      uvms_msgs__msg__TaskPriorityDebug__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

uvms_msgs__msg__TaskPriorityDebug__Sequence *
uvms_msgs__msg__TaskPriorityDebug__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  uvms_msgs__msg__TaskPriorityDebug__Sequence * array = (uvms_msgs__msg__TaskPriorityDebug__Sequence *)allocator.allocate(sizeof(uvms_msgs__msg__TaskPriorityDebug__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = uvms_msgs__msg__TaskPriorityDebug__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
uvms_msgs__msg__TaskPriorityDebug__Sequence__destroy(uvms_msgs__msg__TaskPriorityDebug__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    uvms_msgs__msg__TaskPriorityDebug__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
uvms_msgs__msg__TaskPriorityDebug__Sequence__are_equal(const uvms_msgs__msg__TaskPriorityDebug__Sequence * lhs, const uvms_msgs__msg__TaskPriorityDebug__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!uvms_msgs__msg__TaskPriorityDebug__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
uvms_msgs__msg__TaskPriorityDebug__Sequence__copy(
  const uvms_msgs__msg__TaskPriorityDebug__Sequence * input,
  uvms_msgs__msg__TaskPriorityDebug__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(uvms_msgs__msg__TaskPriorityDebug);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    uvms_msgs__msg__TaskPriorityDebug * data =
      (uvms_msgs__msg__TaskPriorityDebug *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!uvms_msgs__msg__TaskPriorityDebug__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          uvms_msgs__msg__TaskPriorityDebug__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!uvms_msgs__msg__TaskPriorityDebug__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
