// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from uvms_msgs:msg/TaskPriorityDebug.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "uvms_msgs/msg/task_priority_debug.hpp"


#ifndef UVMS_MSGS__MSG__DETAIL__TASK_PRIORITY_DEBUG__STRUCT_HPP_
#define UVMS_MSGS__MSG__DETAIL__TASK_PRIORITY_DEBUG__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__uvms_msgs__msg__TaskPriorityDebug __attribute__((deprecated))
#else
# define DEPRECATED__uvms_msgs__msg__TaskPriorityDebug __declspec(deprecated)
#endif

namespace uvms_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TaskPriorityDebug_
{
  using Type = TaskPriorityDebug_<ContainerAllocator>;

  explicit TaskPriorityDebug_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 10>::iterator, double>(this->desired_velocity.begin(), this->desired_velocity.end(), 0.0);
      std::fill<typename std::array<double, 10>::iterator, double>(this->projected_velocity.begin(), this->projected_velocity.end(), 0.0);
      this->active_tasks = 0ll;
    }
  }

  explicit TaskPriorityDebug_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    desired_velocity(_alloc),
    projected_velocity(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 10>::iterator, double>(this->desired_velocity.begin(), this->desired_velocity.end(), 0.0);
      std::fill<typename std::array<double, 10>::iterator, double>(this->projected_velocity.begin(), this->projected_velocity.end(), 0.0);
      this->active_tasks = 0ll;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _desired_velocity_type =
    std::array<double, 10>;
  _desired_velocity_type desired_velocity;
  using _projected_velocity_type =
    std::array<double, 10>;
  _projected_velocity_type projected_velocity;
  using _active_tasks_type =
    int64_t;
  _active_tasks_type active_tasks;
  using _activation_values_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _activation_values_type activation_values;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__desired_velocity(
    const std::array<double, 10> & _arg)
  {
    this->desired_velocity = _arg;
    return *this;
  }
  Type & set__projected_velocity(
    const std::array<double, 10> & _arg)
  {
    this->projected_velocity = _arg;
    return *this;
  }
  Type & set__active_tasks(
    const int64_t & _arg)
  {
    this->active_tasks = _arg;
    return *this;
  }
  Type & set__activation_values(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->activation_values = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    uvms_msgs::msg::TaskPriorityDebug_<ContainerAllocator> *;
  using ConstRawPtr =
    const uvms_msgs::msg::TaskPriorityDebug_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<uvms_msgs::msg::TaskPriorityDebug_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<uvms_msgs::msg::TaskPriorityDebug_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      uvms_msgs::msg::TaskPriorityDebug_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<uvms_msgs::msg::TaskPriorityDebug_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      uvms_msgs::msg::TaskPriorityDebug_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<uvms_msgs::msg::TaskPriorityDebug_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<uvms_msgs::msg::TaskPriorityDebug_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<uvms_msgs::msg::TaskPriorityDebug_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__uvms_msgs__msg__TaskPriorityDebug
    std::shared_ptr<uvms_msgs::msg::TaskPriorityDebug_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__uvms_msgs__msg__TaskPriorityDebug
    std::shared_ptr<uvms_msgs::msg::TaskPriorityDebug_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TaskPriorityDebug_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->desired_velocity != other.desired_velocity) {
      return false;
    }
    if (this->projected_velocity != other.projected_velocity) {
      return false;
    }
    if (this->active_tasks != other.active_tasks) {
      return false;
    }
    if (this->activation_values != other.activation_values) {
      return false;
    }
    return true;
  }
  bool operator!=(const TaskPriorityDebug_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TaskPriorityDebug_

// alias to use template instance with default allocator
using TaskPriorityDebug =
  uvms_msgs::msg::TaskPriorityDebug_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace uvms_msgs

#endif  // UVMS_MSGS__MSG__DETAIL__TASK_PRIORITY_DEBUG__STRUCT_HPP_
