// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from uvms_msgs:msg/UVMSControlTarget.idl
// generated code does not contain a copyright notice
#include "uvms_msgs/msg/detail/uvms_control_target__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `auv`
#include "hippo_control_msgs/msg/detail/control_target__functions.h"
// Member `manipulator`
#include "alpha_msgs/msg/detail/joint_trajectory__functions.h"

bool
uvms_msgs__msg__UVMSControlTarget__init(uvms_msgs__msg__UVMSControlTarget * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    uvms_msgs__msg__UVMSControlTarget__fini(msg);
    return false;
  }
  // auv
  if (!hippo_control_msgs__msg__ControlTarget__init(&msg->auv)) {
    uvms_msgs__msg__UVMSControlTarget__fini(msg);
    return false;
  }
  // manipulator
  if (!alpha_msgs__msg__JointTrajectory__init(&msg->manipulator)) {
    uvms_msgs__msg__UVMSControlTarget__fini(msg);
    return false;
  }
  return true;
}

void
uvms_msgs__msg__UVMSControlTarget__fini(uvms_msgs__msg__UVMSControlTarget * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // auv
  hippo_control_msgs__msg__ControlTarget__fini(&msg->auv);
  // manipulator
  alpha_msgs__msg__JointTrajectory__fini(&msg->manipulator);
}

bool
uvms_msgs__msg__UVMSControlTarget__are_equal(const uvms_msgs__msg__UVMSControlTarget * lhs, const uvms_msgs__msg__UVMSControlTarget * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // auv
  if (!hippo_control_msgs__msg__ControlTarget__are_equal(
      &(lhs->auv), &(rhs->auv)))
  {
    return false;
  }
  // manipulator
  if (!alpha_msgs__msg__JointTrajectory__are_equal(
      &(lhs->manipulator), &(rhs->manipulator)))
  {
    return false;
  }
  return true;
}

bool
uvms_msgs__msg__UVMSControlTarget__copy(
  const uvms_msgs__msg__UVMSControlTarget * input,
  uvms_msgs__msg__UVMSControlTarget * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // auv
  if (!hippo_control_msgs__msg__ControlTarget__copy(
      &(input->auv), &(output->auv)))
  {
    return false;
  }
  // manipulator
  if (!alpha_msgs__msg__JointTrajectory__copy(
      &(input->manipulator), &(output->manipulator)))
  {
    return false;
  }
  return true;
}

uvms_msgs__msg__UVMSControlTarget *
uvms_msgs__msg__UVMSControlTarget__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  uvms_msgs__msg__UVMSControlTarget * msg = (uvms_msgs__msg__UVMSControlTarget *)allocator.allocate(sizeof(uvms_msgs__msg__UVMSControlTarget), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(uvms_msgs__msg__UVMSControlTarget));
  bool success = uvms_msgs__msg__UVMSControlTarget__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
uvms_msgs__msg__UVMSControlTarget__destroy(uvms_msgs__msg__UVMSControlTarget * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    uvms_msgs__msg__UVMSControlTarget__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
uvms_msgs__msg__UVMSControlTarget__Sequence__init(uvms_msgs__msg__UVMSControlTarget__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  uvms_msgs__msg__UVMSControlTarget * data = NULL;

  if (size) {
    data = (uvms_msgs__msg__UVMSControlTarget *)allocator.zero_allocate(size, sizeof(uvms_msgs__msg__UVMSControlTarget), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = uvms_msgs__msg__UVMSControlTarget__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        uvms_msgs__msg__UVMSControlTarget__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
uvms_msgs__msg__UVMSControlTarget__Sequence__fini(uvms_msgs__msg__UVMSControlTarget__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      uvms_msgs__msg__UVMSControlTarget__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

uvms_msgs__msg__UVMSControlTarget__Sequence *
uvms_msgs__msg__UVMSControlTarget__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  uvms_msgs__msg__UVMSControlTarget__Sequence * array = (uvms_msgs__msg__UVMSControlTarget__Sequence *)allocator.allocate(sizeof(uvms_msgs__msg__UVMSControlTarget__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = uvms_msgs__msg__UVMSControlTarget__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
uvms_msgs__msg__UVMSControlTarget__Sequence__destroy(uvms_msgs__msg__UVMSControlTarget__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    uvms_msgs__msg__UVMSControlTarget__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
uvms_msgs__msg__UVMSControlTarget__Sequence__are_equal(const uvms_msgs__msg__UVMSControlTarget__Sequence * lhs, const uvms_msgs__msg__UVMSControlTarget__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!uvms_msgs__msg__UVMSControlTarget__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
uvms_msgs__msg__UVMSControlTarget__Sequence__copy(
  const uvms_msgs__msg__UVMSControlTarget__Sequence * input,
  uvms_msgs__msg__UVMSControlTarget__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(uvms_msgs__msg__UVMSControlTarget);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    uvms_msgs__msg__UVMSControlTarget * data =
      (uvms_msgs__msg__UVMSControlTarget *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!uvms_msgs__msg__UVMSControlTarget__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          uvms_msgs__msg__UVMSControlTarget__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!uvms_msgs__msg__UVMSControlTarget__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
