// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from uvms_msgs:msg/UVMSControlTarget.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "uvms_msgs/msg/uvms_control_target.h"


#ifndef UVMS_MSGS__MSG__DETAIL__UVMS_CONTROL_TARGET__FUNCTIONS_H_
#define UVMS_MSGS__MSG__DETAIL__UVMS_CONTROL_TARGET__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "uvms_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "uvms_msgs/msg/detail/uvms_control_target__struct.h"

/// Initialize msg/UVMSControlTarget message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * uvms_msgs__msg__UVMSControlTarget
 * )) before or use
 * uvms_msgs__msg__UVMSControlTarget__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
bool
uvms_msgs__msg__UVMSControlTarget__init(uvms_msgs__msg__UVMSControlTarget * msg);

/// Finalize msg/UVMSControlTarget message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
void
uvms_msgs__msg__UVMSControlTarget__fini(uvms_msgs__msg__UVMSControlTarget * msg);

/// Create msg/UVMSControlTarget message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * uvms_msgs__msg__UVMSControlTarget__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
uvms_msgs__msg__UVMSControlTarget *
uvms_msgs__msg__UVMSControlTarget__create(void);

/// Destroy msg/UVMSControlTarget message.
/**
 * It calls
 * uvms_msgs__msg__UVMSControlTarget__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
void
uvms_msgs__msg__UVMSControlTarget__destroy(uvms_msgs__msg__UVMSControlTarget * msg);

/// Check for msg/UVMSControlTarget message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
bool
uvms_msgs__msg__UVMSControlTarget__are_equal(const uvms_msgs__msg__UVMSControlTarget * lhs, const uvms_msgs__msg__UVMSControlTarget * rhs);

/// Copy a msg/UVMSControlTarget message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
bool
uvms_msgs__msg__UVMSControlTarget__copy(
  const uvms_msgs__msg__UVMSControlTarget * input,
  uvms_msgs__msg__UVMSControlTarget * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
const rosidl_type_hash_t *
uvms_msgs__msg__UVMSControlTarget__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
const rosidl_runtime_c__type_description__TypeDescription *
uvms_msgs__msg__UVMSControlTarget__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
const rosidl_runtime_c__type_description__TypeSource *
uvms_msgs__msg__UVMSControlTarget__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
uvms_msgs__msg__UVMSControlTarget__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of msg/UVMSControlTarget messages.
/**
 * It allocates the memory for the number of elements and calls
 * uvms_msgs__msg__UVMSControlTarget__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
bool
uvms_msgs__msg__UVMSControlTarget__Sequence__init(uvms_msgs__msg__UVMSControlTarget__Sequence * array, size_t size);

/// Finalize array of msg/UVMSControlTarget messages.
/**
 * It calls
 * uvms_msgs__msg__UVMSControlTarget__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
void
uvms_msgs__msg__UVMSControlTarget__Sequence__fini(uvms_msgs__msg__UVMSControlTarget__Sequence * array);

/// Create array of msg/UVMSControlTarget messages.
/**
 * It allocates the memory for the array and calls
 * uvms_msgs__msg__UVMSControlTarget__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
uvms_msgs__msg__UVMSControlTarget__Sequence *
uvms_msgs__msg__UVMSControlTarget__Sequence__create(size_t size);

/// Destroy array of msg/UVMSControlTarget messages.
/**
 * It calls
 * uvms_msgs__msg__UVMSControlTarget__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
void
uvms_msgs__msg__UVMSControlTarget__Sequence__destroy(uvms_msgs__msg__UVMSControlTarget__Sequence * array);

/// Check for msg/UVMSControlTarget message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
bool
uvms_msgs__msg__UVMSControlTarget__Sequence__are_equal(const uvms_msgs__msg__UVMSControlTarget__Sequence * lhs, const uvms_msgs__msg__UVMSControlTarget__Sequence * rhs);

/// Copy an array of msg/UVMSControlTarget messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_uvms_msgs
bool
uvms_msgs__msg__UVMSControlTarget__Sequence__copy(
  const uvms_msgs__msg__UVMSControlTarget__Sequence * input,
  uvms_msgs__msg__UVMSControlTarget__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // UVMS_MSGS__MSG__DETAIL__UVMS_CONTROL_TARGET__FUNCTIONS_H_
