// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from uvms_msgs:msg/UVMSControlTarget.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "uvms_msgs/msg/uvms_control_target.hpp"


#ifndef UVMS_MSGS__MSG__DETAIL__UVMS_CONTROL_TARGET__STRUCT_HPP_
#define UVMS_MSGS__MSG__DETAIL__UVMS_CONTROL_TARGET__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'auv'
#include "hippo_control_msgs/msg/detail/control_target__struct.hpp"
// Member 'manipulator'
#include "alpha_msgs/msg/detail/joint_trajectory__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__uvms_msgs__msg__UVMSControlTarget __attribute__((deprecated))
#else
# define DEPRECATED__uvms_msgs__msg__UVMSControlTarget __declspec(deprecated)
#endif

namespace uvms_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct UVMSControlTarget_
{
  using Type = UVMSControlTarget_<ContainerAllocator>;

  explicit UVMSControlTarget_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    auv(_init),
    manipulator(_init)
  {
    (void)_init;
  }

  explicit UVMSControlTarget_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    auv(_alloc, _init),
    manipulator(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _auv_type =
    hippo_control_msgs::msg::ControlTarget_<ContainerAllocator>;
  _auv_type auv;
  using _manipulator_type =
    alpha_msgs::msg::JointTrajectory_<ContainerAllocator>;
  _manipulator_type manipulator;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__auv(
    const hippo_control_msgs::msg::ControlTarget_<ContainerAllocator> & _arg)
  {
    this->auv = _arg;
    return *this;
  }
  Type & set__manipulator(
    const alpha_msgs::msg::JointTrajectory_<ContainerAllocator> & _arg)
  {
    this->manipulator = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    uvms_msgs::msg::UVMSControlTarget_<ContainerAllocator> *;
  using ConstRawPtr =
    const uvms_msgs::msg::UVMSControlTarget_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<uvms_msgs::msg::UVMSControlTarget_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<uvms_msgs::msg::UVMSControlTarget_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      uvms_msgs::msg::UVMSControlTarget_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<uvms_msgs::msg::UVMSControlTarget_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      uvms_msgs::msg::UVMSControlTarget_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<uvms_msgs::msg::UVMSControlTarget_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<uvms_msgs::msg::UVMSControlTarget_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<uvms_msgs::msg::UVMSControlTarget_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__uvms_msgs__msg__UVMSControlTarget
    std::shared_ptr<uvms_msgs::msg::UVMSControlTarget_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__uvms_msgs__msg__UVMSControlTarget
    std::shared_ptr<uvms_msgs::msg::UVMSControlTarget_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const UVMSControlTarget_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->auv != other.auv) {
      return false;
    }
    if (this->manipulator != other.manipulator) {
      return false;
    }
    return true;
  }
  bool operator!=(const UVMSControlTarget_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct UVMSControlTarget_

// alias to use template instance with default allocator
using UVMSControlTarget =
  uvms_msgs::msg::UVMSControlTarget_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace uvms_msgs

#endif  // UVMS_MSGS__MSG__DETAIL__UVMS_CONTROL_TARGET__STRUCT_HPP_
