// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from uvms_msgs:msg/UVMSControlTarget.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "uvms_msgs/msg/uvms_control_target.hpp"


#ifndef UVMS_MSGS__MSG__DETAIL__UVMS_CONTROL_TARGET__TRAITS_HPP_
#define UVMS_MSGS__MSG__DETAIL__UVMS_CONTROL_TARGET__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "uvms_msgs/msg/detail/uvms_control_target__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'auv'
#include "hippo_control_msgs/msg/detail/control_target__traits.hpp"
// Member 'manipulator'
#include "alpha_msgs/msg/detail/joint_trajectory__traits.hpp"

namespace uvms_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const UVMSControlTarget & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: auv
  {
    out << "auv: ";
    to_flow_style_yaml(msg.auv, out);
    out << ", ";
  }

  // member: manipulator
  {
    out << "manipulator: ";
    to_flow_style_yaml(msg.manipulator, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const UVMSControlTarget & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: auv
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "auv:\n";
    to_block_style_yaml(msg.auv, out, indentation + 2);
  }

  // member: manipulator
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "manipulator:\n";
    to_block_style_yaml(msg.manipulator, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const UVMSControlTarget & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace uvms_msgs

namespace rosidl_generator_traits
{

[[deprecated("use uvms_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const uvms_msgs::msg::UVMSControlTarget & msg,
  std::ostream & out, size_t indentation = 0)
{
  uvms_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use uvms_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const uvms_msgs::msg::UVMSControlTarget & msg)
{
  return uvms_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<uvms_msgs::msg::UVMSControlTarget>()
{
  return "uvms_msgs::msg::UVMSControlTarget";
}

template<>
inline const char * name<uvms_msgs::msg::UVMSControlTarget>()
{
  return "uvms_msgs/msg/UVMSControlTarget";
}

template<>
struct has_fixed_size<uvms_msgs::msg::UVMSControlTarget>
  : std::integral_constant<bool, has_fixed_size<alpha_msgs::msg::JointTrajectory>::value && has_fixed_size<hippo_control_msgs::msg::ControlTarget>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<uvms_msgs::msg::UVMSControlTarget>
  : std::integral_constant<bool, has_bounded_size<alpha_msgs::msg::JointTrajectory>::value && has_bounded_size<hippo_control_msgs::msg::ControlTarget>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<uvms_msgs::msg::UVMSControlTarget>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // UVMS_MSGS__MSG__DETAIL__UVMS_CONTROL_TARGET__TRAITS_HPP_
