// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from uvms_msgs:msg/UVMSControlTarget.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "uvms_msgs/msg/detail/uvms_control_target__functions.h"
#include "uvms_msgs/msg/detail/uvms_control_target__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace uvms_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void UVMSControlTarget_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) uvms_msgs::msg::UVMSControlTarget(_init);
}

void UVMSControlTarget_fini_function(void * message_memory)
{
  auto typed_message = static_cast<uvms_msgs::msg::UVMSControlTarget *>(message_memory);
  typed_message->~UVMSControlTarget();
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember UVMSControlTarget_message_member_array[3] = {
  {
    "header",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<std_msgs::msg::Header>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(uvms_msgs::msg::UVMSControlTarget, header),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "auv",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<hippo_control_msgs::msg::ControlTarget>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(uvms_msgs::msg::UVMSControlTarget, auv),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "manipulator",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<alpha_msgs::msg::JointTrajectory>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(uvms_msgs::msg::UVMSControlTarget, manipulator),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers UVMSControlTarget_message_members = {
  "uvms_msgs::msg",  // message namespace
  "UVMSControlTarget",  // message name
  3,  // number of fields
  sizeof(uvms_msgs::msg::UVMSControlTarget),
  false,  // has_any_key_member_
  UVMSControlTarget_message_member_array,  // message members
  UVMSControlTarget_init_function,  // function to initialize message memory (memory has to be allocated)
  UVMSControlTarget_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t UVMSControlTarget_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &UVMSControlTarget_message_members,
  get_message_typesupport_handle_function,
  &uvms_msgs__msg__UVMSControlTarget__get_type_hash,
  &uvms_msgs__msg__UVMSControlTarget__get_type_description,
  &uvms_msgs__msg__UVMSControlTarget__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace uvms_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<uvms_msgs::msg::UVMSControlTarget>()
{
  return &::uvms_msgs::msg::rosidl_typesupport_introspection_cpp::UVMSControlTarget_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, uvms_msgs, msg, UVMSControlTarget)() {
  return &::uvms_msgs::msg::rosidl_typesupport_introspection_cpp::UVMSControlTarget_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
