// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from uvms_msgs:msg/ControlTargetPrediction.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "uvms_msgs/msg/control_target_prediction.hpp"


#ifndef UVMS_MSGS__MSG__DETAIL__CONTROL_TARGET_PREDICTION__STRUCT_HPP_
#define UVMS_MSGS__MSG__DETAIL__CONTROL_TARGET_PREDICTION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'target'
// Member 'target_forward'
#include "hippo_control_msgs/msg/detail/control_target__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__uvms_msgs__msg__ControlTargetPrediction __attribute__((deprecated))
#else
# define DEPRECATED__uvms_msgs__msg__ControlTargetPrediction __declspec(deprecated)
#endif

namespace uvms_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ControlTargetPrediction_
{
  using Type = ControlTargetPrediction_<ContainerAllocator>;

  explicit ControlTargetPrediction_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    target(_init),
    target_forward(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->dt = 0.0;
    }
  }

  explicit ControlTargetPrediction_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    target(_alloc, _init),
    target_forward(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->dt = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _target_type =
    hippo_control_msgs::msg::ControlTarget_<ContainerAllocator>;
  _target_type target;
  using _target_forward_type =
    hippo_control_msgs::msg::ControlTarget_<ContainerAllocator>;
  _target_forward_type target_forward;
  using _dt_type =
    double;
  _dt_type dt;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__target(
    const hippo_control_msgs::msg::ControlTarget_<ContainerAllocator> & _arg)
  {
    this->target = _arg;
    return *this;
  }
  Type & set__target_forward(
    const hippo_control_msgs::msg::ControlTarget_<ContainerAllocator> & _arg)
  {
    this->target_forward = _arg;
    return *this;
  }
  Type & set__dt(
    const double & _arg)
  {
    this->dt = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    uvms_msgs::msg::ControlTargetPrediction_<ContainerAllocator> *;
  using ConstRawPtr =
    const uvms_msgs::msg::ControlTargetPrediction_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<uvms_msgs::msg::ControlTargetPrediction_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<uvms_msgs::msg::ControlTargetPrediction_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      uvms_msgs::msg::ControlTargetPrediction_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<uvms_msgs::msg::ControlTargetPrediction_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      uvms_msgs::msg::ControlTargetPrediction_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<uvms_msgs::msg::ControlTargetPrediction_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<uvms_msgs::msg::ControlTargetPrediction_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<uvms_msgs::msg::ControlTargetPrediction_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__uvms_msgs__msg__ControlTargetPrediction
    std::shared_ptr<uvms_msgs::msg::ControlTargetPrediction_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__uvms_msgs__msg__ControlTargetPrediction
    std::shared_ptr<uvms_msgs::msg::ControlTargetPrediction_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ControlTargetPrediction_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->target != other.target) {
      return false;
    }
    if (this->target_forward != other.target_forward) {
      return false;
    }
    if (this->dt != other.dt) {
      return false;
    }
    return true;
  }
  bool operator!=(const ControlTargetPrediction_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ControlTargetPrediction_

// alias to use template instance with default allocator
using ControlTargetPrediction =
  uvms_msgs::msg::ControlTargetPrediction_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace uvms_msgs

#endif  // UVMS_MSGS__MSG__DETAIL__CONTROL_TARGET_PREDICTION__STRUCT_HPP_
