// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from uvms_msgs:msg/TaskPriorityDebug.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "uvms_msgs/msg/task_priority_debug.hpp"


#ifndef UVMS_MSGS__MSG__DETAIL__TASK_PRIORITY_DEBUG__TRAITS_HPP_
#define UVMS_MSGS__MSG__DETAIL__TASK_PRIORITY_DEBUG__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "uvms_msgs/msg/detail/task_priority_debug__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace uvms_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const TaskPriorityDebug & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: desired_velocity
  {
    if (msg.desired_velocity.size() == 0) {
      out << "desired_velocity: []";
    } else {
      out << "desired_velocity: [";
      size_t pending_items = msg.desired_velocity.size();
      for (auto item : msg.desired_velocity) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: projected_velocity
  {
    if (msg.projected_velocity.size() == 0) {
      out << "projected_velocity: []";
    } else {
      out << "projected_velocity: [";
      size_t pending_items = msg.projected_velocity.size();
      for (auto item : msg.projected_velocity) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: active_tasks
  {
    out << "active_tasks: ";
    rosidl_generator_traits::value_to_yaml(msg.active_tasks, out);
    out << ", ";
  }

  // member: activation_values
  {
    if (msg.activation_values.size() == 0) {
      out << "activation_values: []";
    } else {
      out << "activation_values: [";
      size_t pending_items = msg.activation_values.size();
      for (auto item : msg.activation_values) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const TaskPriorityDebug & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: desired_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.desired_velocity.size() == 0) {
      out << "desired_velocity: []\n";
    } else {
      out << "desired_velocity:\n";
      for (auto item : msg.desired_velocity) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: projected_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.projected_velocity.size() == 0) {
      out << "projected_velocity: []\n";
    } else {
      out << "projected_velocity:\n";
      for (auto item : msg.projected_velocity) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: active_tasks
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "active_tasks: ";
    rosidl_generator_traits::value_to_yaml(msg.active_tasks, out);
    out << "\n";
  }

  // member: activation_values
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.activation_values.size() == 0) {
      out << "activation_values: []\n";
    } else {
      out << "activation_values:\n";
      for (auto item : msg.activation_values) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const TaskPriorityDebug & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace uvms_msgs

namespace rosidl_generator_traits
{

[[deprecated("use uvms_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const uvms_msgs::msg::TaskPriorityDebug & msg,
  std::ostream & out, size_t indentation = 0)
{
  uvms_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use uvms_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const uvms_msgs::msg::TaskPriorityDebug & msg)
{
  return uvms_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<uvms_msgs::msg::TaskPriorityDebug>()
{
  return "uvms_msgs::msg::TaskPriorityDebug";
}

template<>
inline const char * name<uvms_msgs::msg::TaskPriorityDebug>()
{
  return "uvms_msgs/msg/TaskPriorityDebug";
}

template<>
struct has_fixed_size<uvms_msgs::msg::TaskPriorityDebug>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<uvms_msgs::msg::TaskPriorityDebug>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<uvms_msgs::msg::TaskPriorityDebug>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // UVMS_MSGS__MSG__DETAIL__TASK_PRIORITY_DEBUG__TRAITS_HPP_
